%define ocamlver 3.08.1-alt1
%define pcrever 5.09.0-alt1
%set_verify_elf_method textrel=relaxed,rpath=relaxed
Name: ocamlnet
Version: 0.98
Release: alt1

Group: Development/ML
Summary: Network library for OCaml
License: Distributable
Packager: Vitaly Lugovsky <vsl@altlinux.ru>
Url: http://ocamlnet.sourceforge.net
Source:  ocamlnet-%version.tar.gz
Patch: ocamlnet-0.98-inst.patch
Patch1: ocamlnet-0.98-inst2.patch
Requires: ocaml = %ocamlver, findlib >= 1.0.4, pcre-ocaml = %pcrever
Requires: ocamlnet-runtime = %version-%release

BuildRequires: ocaml = %ocamlver, ocamlfind-mini >= 1.0.4, pcre-ocaml = %pcrever

%package runtime
Group: Development/ML
Summary: ocamlnet runtime libraries
Requires: ocaml-runtime = %ocamlver

%description

 The Ocamlnet project will provide a collection of modules for the
Objective Caml language which focus on application-level Internet
protocols and conventions.

The current distribution contains:

- a mature implementation of the CGI protocol

- an experimental POP3 client

- a library of string processing functions related to Internet
  protocols (formerly known as "netstring" and distributed separately)

%description runtime

 OcamlNET library runtime parts

%prep
%setup -q
%patch -p1
%patch1 -p1

%build
cd src
export OCAMLFIND_DESTDIR=$RPM_BUILD_ROOT/usr/lib/ocaml/site-lib/
export OCAMLPATH=/usr/lib/ocaml/site-lib/
./configure -datadir /usr/lib/ocaml/site-lib/netstring/ -enable-findlib
make
make opt

#cd cgi
#ocamlopt -nolinkstd -shared -o cgi.so stdlib.so.cmxa cgi.cmxa -linkall
#cd ../netstring
#ocamlopt -nolinkstd -shared -o netstring.so stdlib.so.cmxa netstring.cmxa -linkall

%install
%define _compress_method skip

cd src
export OCAMLPATH=/usr/lib/ocaml/site-lib/
export OCAMLFIND_DESTDIR=$RPM_BUILD_ROOT/usr/lib/ocaml/site-lib/
export NET_DB_DIR2=$RPM_BUILD_ROOT/usr/lib/ocaml/site-lib/netstring/
mkdir -p $RPM_BUILD_ROOT/usr/lib/ocaml/site-lib/
make install
cp cgi/{*.a,*.cmxa} $RPM_BUILD_ROOT/usr/lib/ocaml/site-lib/cgi/
cp netstring/{*.a,*.cmxa} $RPM_BUILD_ROOT/usr/lib/ocaml/site-lib/netstring/
mkdir -p $RPM_BUILD_ROOT/usr/lib/ocaml/stublibs/
#ln -s /usr/lib/ocaml/site-lib/cgi/cgi.so $RPM_BUILD_ROOT/usr/lib/ocaml/stublibs/cgi.so 
#ln -s /usr/lib/ocaml/site-lib/netstring/netstring.so $RPM_BUILD_ROOT/usr/lib/ocaml/stublibs/netstring.so

cd ..

(cd $RPM_BUILD_ROOT; find usr/lib/ocaml/site-lib ! -type d  ! -name '*.so' -printf "/%%p\n") > files
(cd $RPM_BUILD_ROOT; find usr/lib/ocaml/ -name '*.so' -printf "/%%p\n") > runfiles


%files -f files
%doc README src/INSTALL src/INSTALL.jserv 

%files runtime -f runfiles
%dir %_libdir/ocaml/site-lib/cgi
%dir %_libdir/ocaml/site-lib/netstring

%changelog
* Mon Nov 01 2004 Vitaly Lugovsky <vsl@altlinux.ru> 0.98-alt1
- new version

* Sun Jul 18 2004 Vitaly Lugovsky <vsl@altlinux.ru> 0.97-alt6
- rebuild

* Wed Jul 07 2004 Vitaly Lugovsky <vsl@altlinux.ru> 0.97-alt5
- rebuild

* Fri May  7 2004 Alexander V. Nikolaev <avn@altlinux.org> 0.97-alt4.1
- Non-maintainer upload
- Add "packager" to spec
- Rebuild with glibc 2.3.x and ocaml 3.07-alt6.1

* Wed Mar 17 2004 Vitaly Lugovsky <vsl@altlinux.ru> 0.97-alt4
rebuild


* Wed Feb 18 2004 Vitaly Lugovsky <vsl@altlinux.ru> 0.97-alt3
- rebuild

* Tue Jan 27 2004 Vitaly Lugovsky <vsl@altlinux.ru> 0.97-alt2
rebuild

* Tue Dec 16 2003 Vitaly Lugovsky <vsl@altlinux.ru> 0.97-alt1
a new version

* Wed Nov 12 2003 Vitaly Lugovsky <vsl@altlinux.ru> 0.96-alt5
relaxed elf verifying

* Fri Oct 10 2003 Vitaly Lugovsky <vsl@altlinux.ru> 0.96-alt4s
rebuild


* Wed Aug 27 2003 Vitaly Lugovsky <vsl@altlinux.ru> 0.96-alt3s
- rebuild (3.07bs)

* Sat Jun 28 2003 Vitaly Lugovsky <vsl@altlinux.ru> 0.96-alt2s
- bugfix (wrong installation paths for a codepage files fixed)

* Tue Jun 24 2003 Vitaly Lugovsky <vsl@altlinux.ru> 0.96-alt1s
- a new version

* Sat Mar 15 2003 Vitaly Lugovsky <vsl@altlinux.ru> 0.95-alt1s
- new version

* Fri Jan 31 2003 Vitaly Lugovsky <vsl@altlinux.ru> 0.94-alt1s
- rebuild with shared libs support

* Fri Jan 24 2003 Vitaly Lugovsky <vsl@altlinux.ru> 0.94-alt1
- new version

* Thu Aug 29 2002 Vitaly Lugovsky <vsl@altlinux.ru> 0.93-alt1
- new version

*Tue Jul 30 2002 Vitaly Lugovsky <vsl@altlinux.ru> 0.92-alt3
- rebuild: ocaml 3.05

*Tue Jun 25 2002 Vitaly Lugovsky <vsl@altlinux.ru> 0.92-alt2
- strange ocamlfind-mini bug fixed

*Mon Jun 24 2002 Vitaly Lugovsky <vsl@altlinux.ru>
- First RPM release.

